Index: palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_2d.f90	(revision 4670)
+++ palm/trunk/SOURCE/data_output_2d.f90	(revision 4671)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! ------------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+! 
+! 4559 2020-06-11 08:51:48Z raasch
 ! file re-formatted to follow the PALM coding standard
 !
@@ -441,18 +444,18 @@
              CASE ( 'ghf*_xy' )        ! 2d-array
                 IF ( av == 0 )  THEN
-                   DO  m = 1, surf_lsm_h%ns
-                      i                   = surf_lsm_h%i(m)
-                      j                   = surf_lsm_h%j(m)
-                      local_pf(i,j,nzb+1) = surf_lsm_h%ghf(m)
-                   ENDDO
-                   DO  m = 1, surf_usm_h%ns
-                      i                   = surf_usm_h%i(m)
-                      j                   = surf_usm_h%j(m)
-                      local_pf(i,j,nzb+1) = surf_usm_h%frac(m,ind_veg_wall)  *                     &
-                                            surf_usm_h%wghf_eb(m)        +                         &
-                                            surf_usm_h%frac(m,ind_pav_green) *                     &
-                                            surf_usm_h%wghf_eb_green(m)  +                         &
-                                            surf_usm_h%frac(m,ind_wat_win)   *                     &
-                                            surf_usm_h%wghf_eb_window(m)
+                   DO  m = 1, surf_lsm_h(0)%ns
+                      i                   = surf_lsm_h(0)%i(m)
+                      j                   = surf_lsm_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = surf_lsm_h(0)%ghf(m)
+                   ENDDO
+                   DO  m = 1, surf_usm_h(0)%ns
+                      i                   = surf_usm_h(0)%i(m)
+                      j                   = surf_usm_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = surf_usm_h(0)%frac(m,ind_veg_wall)  *                     &
+                                            surf_usm_h(0)%wghf_eb(m)        +                         &
+                                            surf_usm_h(0)%frac(m,ind_pav_green) *                     &
+                                            surf_usm_h(0)%wghf_eb_green(m)  +                         &
+                                            surf_usm_h(0)%frac(m,ind_wat_win)   *                     &
+                                            surf_usm_h(0)%wghf_eb_window(m)
                    ENDDO
                 ELSE
@@ -479,13 +482,13 @@
                       local_pf(i,j,nzb+1) = surf_def_h(0)%ol(m)
                    ENDDO
-                   DO  m = 1, surf_lsm_h%ns
-                      i = surf_lsm_h%i(m)
-                      j = surf_lsm_h%j(m)
-                      local_pf(i,j,nzb+1) = surf_lsm_h%ol(m)
-                   ENDDO
-                   DO  m = 1, surf_usm_h%ns
-                      i = surf_usm_h%i(m)
-                      j = surf_usm_h%j(m)
-                      local_pf(i,j,nzb+1) = surf_usm_h%ol(m)
+                   DO  m = 1, surf_lsm_h(0)%ns
+                      i = surf_lsm_h(0)%i(m)
+                      j = surf_lsm_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = surf_lsm_h(0)%ol(m)
+                   ENDDO
+                   DO  m = 1, surf_usm_h(0)%ns
+                      i = surf_usm_h(0)%i(m)
+                      j = surf_usm_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = surf_usm_h(0)%ol(m)
                    ENDDO
                 ELSE
@@ -711,14 +714,14 @@
                    ENDDO
 
-                   DO  m = 1, surf_lsm_h%ns
-                      i                   = surf_lsm_h%i(m)
-                      j                   = surf_lsm_h%j(m)
-                      local_pf(i,j,nzb+1) = surf_lsm_h%q_surface(m)
-                   ENDDO
-
-                   DO  m = 1, surf_usm_h%ns
-                      i                   = surf_usm_h%i(m)
-                      j                   = surf_usm_h%j(m)
-                      local_pf(i,j,nzb+1) = surf_usm_h%q_surface(m)
+                   DO  m = 1, surf_lsm_h(0)%ns
+                      i                   = surf_lsm_h(0)%i(m)
+                      j                   = surf_lsm_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = surf_lsm_h(0)%q_surface(m)
+                   ENDDO
+
+                   DO  m = 1, surf_usm_h(0)%ns
+                      i                   = surf_usm_h(0)%i(m)
+                      j                   = surf_usm_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = surf_usm_h(0)%q_surface(m)
                    ENDDO
 
@@ -750,15 +753,15 @@
                       local_pf(i,j,nzb+1) = surf_def_h(0)%qsws(m) * waterflux_output_conversion(k)
                    ENDDO
-                   DO  m = 1, surf_lsm_h%ns
-                      i = surf_lsm_h%i(m)
-                      j = surf_lsm_h%j(m)
-                      k = surf_lsm_h%k(m)
-                      local_pf(i,j,nzb+1) = surf_lsm_h%qsws(m) * waterflux_output_conversion(k)
-                   ENDDO
-                   DO  m = 1, surf_usm_h%ns
-                      i = surf_usm_h%i(m)
-                      j = surf_usm_h%j(m)
-                      k = surf_usm_h%k(m)
-                      local_pf(i,j,nzb+1) = surf_usm_h%qsws(m) * waterflux_output_conversion(k)
+                   DO  m = 1, surf_lsm_h(0)%ns
+                      i = surf_lsm_h(0)%i(m)
+                      j = surf_lsm_h(0)%j(m)
+                      k = surf_lsm_h(0)%k(m)
+                      local_pf(i,j,nzb+1) = surf_lsm_h(0)%qsws(m) * waterflux_output_conversion(k)
+                   ENDDO
+                   DO  m = 1, surf_usm_h(0)%ns
+                      i = surf_usm_h(0)%i(m)
+                      j = surf_usm_h(0)%j(m)
+                      k = surf_usm_h(0)%k(m)
+                      local_pf(i,j,nzb+1) = surf_usm_h(0)%qsws(m) * waterflux_output_conversion(k)
                    ENDDO
                 ELSE
@@ -798,19 +801,19 @@
              CASE ( 'r_a*_xy' )        ! 2d-array
                 IF ( av == 0 )  THEN
-                   DO  m = 1, surf_lsm_h%ns
-                      i                   = surf_lsm_h%i(m)
-                      j                   = surf_lsm_h%j(m)
-                      local_pf(i,j,nzb+1) = surf_lsm_h%r_a(m)
-                   ENDDO
-
-                   DO  m = 1, surf_usm_h%ns
-                      i   = surf_usm_h%i(m)
-                      j   = surf_usm_h%j(m)
-                      local_pf(i,j,nzb+1) = ( surf_usm_h%frac(m,ind_veg_wall)  *                   &
-                                              surf_usm_h%r_a(m)       +                            &
-                                              surf_usm_h%frac(m,ind_pav_green) *                   &
-                                              surf_usm_h%r_a_green(m) +                            &
-                                              surf_usm_h%frac(m,ind_wat_win)   *                   &
-                                              surf_usm_h%r_a_window(m) )
+                   DO  m = 1, surf_lsm_h(0)%ns
+                      i                   = surf_lsm_h(0)%i(m)
+                      j                   = surf_lsm_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = surf_lsm_h(0)%r_a(m)
+                   ENDDO
+
+                   DO  m = 1, surf_usm_h(0)%ns
+                      i   = surf_usm_h(0)%i(m)
+                      j   = surf_usm_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = ( surf_usm_h(0)%frac(m,ind_veg_wall)  *                   &
+                                              surf_usm_h(0)%r_a(m)       +                            &
+                                              surf_usm_h(0)%frac(m,ind_pav_green) *                   &
+                                              surf_usm_h(0)%r_a_green(m) +                            &
+                                              surf_usm_h(0)%frac(m,ind_wat_win)   *                   &
+                                              surf_usm_h(0)%r_a_window(m) )
                    ENDDO
                 ELSE
@@ -851,15 +854,15 @@
                       local_pf(i,j,nzb+1) = surf_def_h(0)%shf(m) * heatflux_output_conversion(k)
                    ENDDO
-                   DO  m = 1, surf_lsm_h%ns
-                      i = surf_lsm_h%i(m)
-                      j = surf_lsm_h%j(m)
-                      k = surf_lsm_h%k(m)
-                      local_pf(i,j,nzb+1) = surf_lsm_h%shf(m) * heatflux_output_conversion(k)
-                   ENDDO
-                   DO  m = 1, surf_usm_h%ns
-                      i = surf_usm_h%i(m)
-                      j = surf_usm_h%j(m)
-                      k = surf_usm_h%k(m)
-                      local_pf(i,j,nzb+1) = surf_usm_h%shf(m) * heatflux_output_conversion(k)
+                   DO  m = 1, surf_lsm_h(0)%ns
+                      i = surf_lsm_h(0)%i(m)
+                      j = surf_lsm_h(0)%j(m)
+                      k = surf_lsm_h(0)%k(m)
+                      local_pf(i,j,nzb+1) = surf_lsm_h(0)%shf(m) * heatflux_output_conversion(k)
+                   ENDDO
+                   DO  m = 1, surf_usm_h(0)%ns
+                      i = surf_usm_h(0)%i(m)
+                      j = surf_usm_h(0)%j(m)
+                      k = surf_usm_h(0)%k(m)
+                      local_pf(i,j,nzb+1) = surf_usm_h(0)%shf(m) * heatflux_output_conversion(k)
                    ENDDO
                 ELSE
@@ -908,13 +911,13 @@
                       local_pf(i,j,nzb+1) = surf_def_h(0)%ssws(m)
                    ENDDO
-                   DO  m = 1, surf_lsm_h%ns
-                      i = surf_lsm_h%i(m)
-                      j = surf_lsm_h%j(m)
-                      local_pf(i,j,nzb+1) = surf_lsm_h%ssws(m)
-                   ENDDO
-                   DO  m = 1, surf_usm_h%ns
-                      i = surf_usm_h%i(m)
-                      j = surf_usm_h%j(m)
-                      local_pf(i,j,nzb+1) = surf_usm_h%ssws(m)
+                   DO  m = 1, surf_lsm_h(0)%ns
+                      i = surf_lsm_h(0)%i(m)
+                      j = surf_lsm_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = surf_lsm_h(0)%ssws(m)
+                   ENDDO
+                   DO  m = 1, surf_usm_h(0)%ns
+                      i = surf_usm_h(0)%i(m)
+                      j = surf_usm_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = surf_usm_h(0)%ssws(m)
                    ENDDO
                 ELSE
@@ -940,13 +943,13 @@
                       local_pf(i,j,nzb+1) = surf_def_h(0)%ts(m)
                    ENDDO
-                   DO  m = 1, surf_lsm_h%ns
-                      i = surf_lsm_h%i(m)
-                      j = surf_lsm_h%j(m)
-                      local_pf(i,j,nzb+1) = surf_lsm_h%ts(m)
-                   ENDDO
-                   DO  m = 1, surf_usm_h%ns
-                      i = surf_usm_h%i(m)
-                      j = surf_usm_h%j(m)
-                      local_pf(i,j,nzb+1) = surf_usm_h%ts(m)
+                   DO  m = 1, surf_lsm_h(0)%ns
+                      i = surf_lsm_h(0)%i(m)
+                      j = surf_lsm_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = surf_lsm_h(0)%ts(m)
+                   ENDDO
+                   DO  m = 1, surf_usm_h(0)%ns
+                      i = surf_usm_h(0)%i(m)
+                      j = surf_usm_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = surf_usm_h(0)%ts(m)
                    ENDDO
                 ELSE
@@ -973,14 +976,14 @@
                    ENDDO
 
-                   DO  m = 1, surf_lsm_h%ns
-                      i                   = surf_lsm_h%i(m)
-                      j                   = surf_lsm_h%j(m)
-                      local_pf(i,j,nzb+1) = surf_lsm_h%pt_surface(m)
-                   ENDDO
-
-                   DO  m = 1, surf_usm_h%ns
-                      i   = surf_usm_h%i(m)
-                      j   = surf_usm_h%j(m)
-                      local_pf(i,j,nzb+1) = surf_usm_h%pt_surface(m)
+                   DO  m = 1, surf_lsm_h(0)%ns
+                      i                   = surf_lsm_h(0)%i(m)
+                      j                   = surf_lsm_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = surf_lsm_h(0)%pt_surface(m)
+                   ENDDO
+
+                   DO  m = 1, surf_usm_h(0)%ns
+                      i   = surf_usm_h(0)%i(m)
+                      j   = surf_usm_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = surf_usm_h(0)%pt_surface(m)
                    ENDDO
 
@@ -1026,13 +1029,13 @@
                       local_pf(i,j,nzb+1) = surf_def_h(0)%us(m)
                    ENDDO
-                   DO  m = 1, surf_lsm_h%ns
-                      i = surf_lsm_h%i(m)
-                      j = surf_lsm_h%j(m)
-                      local_pf(i,j,nzb+1) = surf_lsm_h%us(m)
-                   ENDDO
-                   DO  m = 1, surf_usm_h%ns
-                      i = surf_usm_h%i(m)
-                      j = surf_usm_h%j(m)
-                      local_pf(i,j,nzb+1) = surf_usm_h%us(m)
+                   DO  m = 1, surf_lsm_h(0)%ns
+                      i = surf_lsm_h(0)%i(m)
+                      j = surf_lsm_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = surf_lsm_h(0)%us(m)
+                   ENDDO
+                   DO  m = 1, surf_usm_h(0)%ns
+                      i = surf_usm_h(0)%i(m)
+                      j = surf_usm_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = surf_usm_h(0)%us(m)
                    ENDDO
                 ELSE
@@ -1102,13 +1105,13 @@
                       local_pf(i,j,nzb+1) = surf_def_h(0)%z0(m)
                    ENDDO
-                   DO  m = 1, surf_lsm_h%ns
-                      i = surf_lsm_h%i(m)
-                      j = surf_lsm_h%j(m)
-                      local_pf(i,j,nzb+1) = surf_lsm_h%z0(m)
-                   ENDDO
-                   DO  m = 1, surf_usm_h%ns
-                      i = surf_usm_h%i(m)
-                      j = surf_usm_h%j(m)
-                      local_pf(i,j,nzb+1) = surf_usm_h%z0(m)
+                   DO  m = 1, surf_lsm_h(0)%ns
+                      i = surf_lsm_h(0)%i(m)
+                      j = surf_lsm_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = surf_lsm_h(0)%z0(m)
+                   ENDDO
+                   DO  m = 1, surf_usm_h(0)%ns
+                      i = surf_usm_h(0)%i(m)
+                      j = surf_usm_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = surf_usm_h(0)%z0(m)
                    ENDDO
                 ELSE
@@ -1134,13 +1137,13 @@
                       local_pf(i,j,nzb+1) = surf_def_h(0)%z0h(m)
                    ENDDO
-                   DO  m = 1, surf_lsm_h%ns
-                      i = surf_lsm_h%i(m)
-                      j = surf_lsm_h%j(m)
-                      local_pf(i,j,nzb+1) = surf_lsm_h%z0h(m)
-                   ENDDO
-                   DO  m = 1, surf_usm_h%ns
-                      i = surf_usm_h%i(m)
-                      j = surf_usm_h%j(m)
-                      local_pf(i,j,nzb+1) = surf_usm_h%z0h(m)
+                   DO  m = 1, surf_lsm_h(0)%ns
+                      i = surf_lsm_h(0)%i(m)
+                      j = surf_lsm_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = surf_lsm_h(0)%z0h(m)
+                   ENDDO
+                   DO  m = 1, surf_usm_h(0)%ns
+                      i = surf_usm_h(0)%i(m)
+                      j = surf_usm_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = surf_usm_h(0)%z0h(m)
                    ENDDO
                 ELSE
@@ -1166,13 +1169,13 @@
                       local_pf(i,j,nzb+1) = surf_def_h(0)%z0q(m)
                    ENDDO
-                   DO  m = 1, surf_lsm_h%ns
-                      i = surf_lsm_h%i(m)
-                      j = surf_lsm_h%j(m)
-                      local_pf(i,j,nzb+1) = surf_lsm_h%z0q(m)
-                   ENDDO
-                   DO  m = 1, surf_usm_h%ns
-                      i = surf_usm_h%i(m)
-                      j = surf_usm_h%j(m)
-                      local_pf(i,j,nzb+1) = surf_usm_h%z0q(m)
+                   DO  m = 1, surf_lsm_h(0)%ns
+                      i = surf_lsm_h(0)%i(m)
+                      j = surf_lsm_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = surf_lsm_h(0)%z0q(m)
+                   ENDDO
+                   DO  m = 1, surf_usm_h(0)%ns
+                      i = surf_usm_h(0)%i(m)
+                      j = surf_usm_h(0)%j(m)
+                      local_pf(i,j,nzb+1) = surf_usm_h(0)%z0q(m)
                    ENDDO
                 ELSE
Index: palm/trunk/SOURCE/diagnostic_output_quantities_mod.f90
===================================================================
--- palm/trunk/SOURCE/diagnostic_output_quantities_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/diagnostic_output_quantities_mod.f90	(revision 4671)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! ------------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+! 
+! 4583 2020-06-29 12:36:47Z raasch
 ! file re-formatted to follow the PALM coding standard
 !
@@ -1693,7 +1696,7 @@
              surf => surf_def_h(0)
              CALL calc_pt_2m
-             surf => surf_lsm_h
+             surf => surf_lsm_h(0)
              CALL calc_pt_2m
-             surf => surf_usm_h
+             surf => surf_usm_h(0)
              CALL calc_pt_2m
 !
@@ -1707,7 +1710,7 @@
              surf => surf_def_h(0)
              CALL calc_wind_10m
-             surf => surf_lsm_h
+             surf => surf_lsm_h(0)
              CALL calc_wind_10m
-             surf => surf_usm_h
+             surf => surf_usm_h(0)
              CALL calc_wind_10m
 !
Index: palm/trunk/SOURCE/diffusion_s.f90
===================================================================
--- palm/trunk/SOURCE/diffusion_s.f90	(revision 4670)
+++ palm/trunk/SOURCE/diffusion_s.f90	(revision 4671)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! ------------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+! 
+! 4583 2020-06-29 12:36:47Z raasch
 ! file re-formatted to follow the PALM coding standard
 !
@@ -74,5 +77,6 @@
     SUBROUTINE diffusion_s( s, s_flux_def_h_up,    s_flux_def_h_down,                              &
                                s_flux_t,                                                           &
-                               s_flux_lsm_h_up,    s_flux_usm_h_up,                                &
+                               s_flux_lsm_h_up,    s_flux_lsm_h_down,                              &
+                               s_flux_usm_h_up,    s_flux_usm_h_down,                              &
                                s_flux_def_v_north, s_flux_def_v_south,                             &
                                s_flux_def_v_east,  s_flux_def_v_west,                              &
@@ -116,16 +120,18 @@
        REAL(wp) ::  mask_west         !< flag to mask vertical surface west of the grid point
 
+       REAL(wp), DIMENSION(1:surf_def_h(0)%ns) ::  s_flux_def_h_up    !< flux at horizontal upward-facing default-type surfaces
        REAL(wp), DIMENSION(1:surf_def_h(1)%ns) ::  s_flux_def_h_down  !< flux at horizontal donwward-facing default-type surfaces
-       REAL(wp), DIMENSION(1:surf_def_h(0)%ns) ::  s_flux_def_h_up    !< flux at horizontal upward-facing default-type surfaces
        REAL(wp), DIMENSION(1:surf_def_v(2)%ns) ::  s_flux_def_v_east  !< flux at east-facing vertical default-type surfaces
        REAL(wp), DIMENSION(1:surf_def_v(0)%ns) ::  s_flux_def_v_north !< flux at north-facing vertical default-type surfaces
        REAL(wp), DIMENSION(1:surf_def_v(1)%ns) ::  s_flux_def_v_south !< flux at south-facing vertical default-type surfaces
        REAL(wp), DIMENSION(1:surf_def_v(3)%ns) ::  s_flux_def_v_west  !< flux at west-facing vertical default-type surfaces
-       REAL(wp), DIMENSION(1:surf_lsm_h%ns)    ::  s_flux_lsm_h_up    !< flux at horizontal upward-facing natural-type surfaces
+       REAL(wp), DIMENSION(1:surf_lsm_h(0)%ns) ::  s_flux_lsm_h_up    !< flux at horizontal upward-facing natural-type surfaces
+       REAL(wp), DIMENSION(1:surf_lsm_h(1)%ns) ::  s_flux_lsm_h_down  !< flux at horizontal downward-facing natural-type surfaces
        REAL(wp), DIMENSION(1:surf_lsm_v(2)%ns) ::  s_flux_lsm_v_east  !< flux at east-facing vertical natural-type surfaces
        REAL(wp), DIMENSION(1:surf_lsm_v(0)%ns) ::  s_flux_lsm_v_north !< flux at north-facing vertical natural-type surfaces
        REAL(wp), DIMENSION(1:surf_lsm_v(1)%ns) ::  s_flux_lsm_v_south !< flux at south-facing vertical natural-type surfaces
        REAL(wp), DIMENSION(1:surf_lsm_v(3)%ns) ::  s_flux_lsm_v_west  !< flux at west-facing vertical natural-type surfaces
-       REAL(wp), DIMENSION(1:surf_usm_h%ns)    ::  s_flux_usm_h_up    !< flux at horizontal upward-facing urban-type surfaces
+       REAL(wp), DIMENSION(1:surf_usm_h(0)%ns) ::  s_flux_usm_h_up    !< flux at horizontal upward-facing urban-type surfaces
+       REAL(wp), DIMENSION(1:surf_usm_h(1)%ns) ::  s_flux_usm_h_down  !< flux at horizontal downward-facing urban-type surfaces
        REAL(wp), DIMENSION(1:surf_usm_v(2)%ns) ::  s_flux_usm_v_east  !< flux at east-facing vertical urban-type surfaces
        REAL(wp), DIMENSION(1:surf_usm_v(0)%ns) ::  s_flux_usm_v_north !< flux at north-facing vertical urban-type surfaces
@@ -144,14 +150,14 @@
        !$ACC PRESENT(ddzu, ddzw, drho_air, rho_air_zw) &
        !$ACC PRESENT(surf_def_h(0:2), surf_def_v(0:3)) &
-       !$ACC PRESENT(surf_lsm_h, surf_lsm_v(0:3)) &
-       !$ACC PRESENT(surf_usm_h, surf_usm_v(0:3)) &
+       !$ACC PRESENT(surf_lsm_h(0:1), surf_lsm_v(0:3)) &
+       !$ACC PRESENT(surf_usm_h(0:1), surf_usm_v(0:3)) &
        !$ACC PRESENT(s_flux_def_h_up, s_flux_def_h_down) &
        !$ACC PRESENT(s_flux_t) &
        !$ACC PRESENT(s_flux_def_v_north, s_flux_def_v_south) &
        !$ACC PRESENT(s_flux_def_v_east, s_flux_def_v_west) &
-       !$ACC PRESENT(s_flux_lsm_h_up) &
+       !$ACC PRESENT(s_flux_lsm_h_up, s_flux_lsm_h_down) &
        !$ACC PRESENT(s_flux_lsm_v_north, s_flux_lsm_v_south) &
        !$ACC PRESENT(s_flux_lsm_v_east, s_flux_lsm_v_west) &
-       !$ACC PRESENT(s_flux_usm_h_up) &
+       !$ACC PRESENT(s_flux_usm_h_up, s_flux_usm_h_down) &
        !$ACC PRESENT(s_flux_usm_v_north, s_flux_usm_v_south) &
        !$ACC PRESENT(s_flux_usm_v_east, s_flux_usm_v_west) &
@@ -328,8 +334,6 @@
                 surf_e = surf_def_h(0)%end_index(j,i)
                 DO  m = surf_s, surf_e
-
                    k   = surf_def_h(0)%k(m)
                    tend(k,j,i) = tend(k,j,i) + s_flux_def_h_up(m) * ddzw(k) * drho_air(k)
-
                 ENDDO
 !
@@ -338,28 +342,38 @@
                 surf_e = surf_def_h(1)%end_index(j,i)
                 DO  m = surf_s, surf_e
-
                    k   = surf_def_h(1)%k(m)
                    tend(k,j,i) = tend(k,j,i) + s_flux_def_h_down(m) * ddzw(k) * drho_air(k)
-
                 ENDDO
 !
 !--             Natural-type surfaces, upward-facing
-                surf_s = surf_lsm_h%start_index(j,i)
-                surf_e = surf_lsm_h%end_index(j,i)
+                surf_s = surf_lsm_h(0)%start_index(j,i)
+                surf_e = surf_lsm_h(0)%end_index(j,i)
                 DO  m = surf_s, surf_e
-
-                   k   = surf_lsm_h%k(m)
+                   k   = surf_lsm_h(0)%k(m)
                    tend(k,j,i) = tend(k,j,i) + s_flux_lsm_h_up(m) * ddzw(k) * drho_air(k)
-
                 ENDDO
 !
+!--             Natural-type surfaces, downward-facing
+                surf_s = surf_lsm_h(1)%start_index(j,i)
+                surf_e = surf_lsm_h(1)%end_index(j,i)
+                DO  m = surf_s, surf_e
+                   k   = surf_lsm_h(1)%k(m)
+                   tend(k,j,i) = tend(k,j,i) + s_flux_lsm_h_down(m) * ddzw(k) * drho_air(k)
+                ENDDO
+!
 !--             Urban-type surfaces, upward-facing
-                surf_s = surf_usm_h%start_index(j,i)
-                surf_e = surf_usm_h%end_index(j,i)
+                surf_s = surf_usm_h(0)%start_index(j,i)
+                surf_e = surf_usm_h(0)%end_index(j,i)
                 DO  m = surf_s, surf_e
-
-                   k   = surf_usm_h%k(m)
+                   k   = surf_usm_h(0)%k(m)
                    tend(k,j,i) = tend(k,j,i) + s_flux_usm_h_up(m) * ddzw(k) * drho_air(k)
-
+                ENDDO
+!
+!--             Urban-type surfaces, downward-facing
+                surf_s = surf_usm_h(1)%start_index(j,i)
+                surf_e = surf_usm_h(1)%end_index(j,i)
+                DO  m = surf_s, surf_e
+                   k   = surf_usm_h(1)%k(m)
+                   tend(k,j,i) = tend(k,j,i) + s_flux_usm_h_down(m) * ddzw(k) * drho_air(k)
                 ENDDO
 
@@ -390,5 +404,6 @@
                                s_flux_def_h_up,    s_flux_def_h_down,                              &
                                s_flux_t,                                                           &
-                               s_flux_lsm_h_up,    s_flux_usm_h_up,                                &
+                               s_flux_lsm_h_up,    s_flux_lsm_h_down,                              &
+                               s_flux_usm_h_up,    s_flux_usm_h_down,                              &
                                s_flux_def_v_north, s_flux_def_v_south,                             &
                                s_flux_def_v_east,  s_flux_def_v_west,                              &
@@ -438,10 +453,12 @@
        REAL(wp), DIMENSION(1:surf_def_v(1)%ns) ::  s_flux_def_v_south !< flux at south-facing vertical default-type surfaces
        REAL(wp), DIMENSION(1:surf_def_v(3)%ns) ::  s_flux_def_v_west  !< flux at west-facing vertical default-type surfaces
-       REAL(wp), DIMENSION(1:surf_lsm_h%ns)    ::  s_flux_lsm_h_up    !< flux at horizontal upward-facing natural-type surfaces
+       REAL(wp), DIMENSION(1:surf_lsm_h(0)%ns) ::  s_flux_lsm_h_up    !< flux at horizontal upward-facing natural-type surfaces
+       REAL(wp), DIMENSION(1:surf_lsm_h(1)%ns) ::  s_flux_lsm_h_down    !< flux at horizontal downward-facing natural-type surfaces
        REAL(wp), DIMENSION(1:surf_lsm_v(2)%ns) ::  s_flux_lsm_v_east  !< flux at east-facing vertical urban-type surfaces
        REAL(wp), DIMENSION(1:surf_lsm_v(0)%ns) ::  s_flux_lsm_v_north !< flux at north-facing vertical urban-type surfaces
        REAL(wp), DIMENSION(1:surf_lsm_v(1)%ns) ::  s_flux_lsm_v_south !< flux at south-facing vertical urban-type surfaces
        REAL(wp), DIMENSION(1:surf_lsm_v(3)%ns) ::  s_flux_lsm_v_west  !< flux at west-facing vertical urban-type surfaces
-       REAL(wp), DIMENSION(1:surf_usm_h%ns)    ::  s_flux_usm_h_up    !< flux at horizontal upward-facing urban-type surfaces
+       REAL(wp), DIMENSION(1:surf_usm_h(0)%ns) ::  s_flux_usm_h_up    !< flux at horizontal upward-facing urban-type surfaces
+       REAL(wp), DIMENSION(1:surf_usm_h(1)%ns) ::  s_flux_usm_h_down  !< flux at horizontal downward-facing urban-type surfaces
        REAL(wp), DIMENSION(1:surf_usm_v(2)%ns) ::  s_flux_usm_v_east  !< flux at east-facing vertical urban-type surfaces
        REAL(wp), DIMENSION(1:surf_usm_v(0)%ns) ::  s_flux_usm_v_north !< flux at north-facing vertical urban-type surfaces
@@ -625,7 +642,5 @@
           surf_e = surf_def_h(0)%end_index(j,i)
           DO  m = surf_s, surf_e
-
              k   = surf_def_h(0)%k(m)
-
              tend(k,j,i) = tend(k,j,i) + s_flux_def_h_up(m) * ddzw(k) * drho_air(k)
           ENDDO
@@ -635,26 +650,38 @@
           surf_e = surf_def_h(1)%end_index(j,i)
           DO  m = surf_s, surf_e
-
              k   = surf_def_h(1)%k(m)
-
              tend(k,j,i) = tend(k,j,i) + s_flux_def_h_down(m) * ddzw(k) * drho_air(k)
           ENDDO
 !
 !--       Natural-type surfaces, upward-facing
-          surf_s = surf_lsm_h%start_index(j,i)
-          surf_e = surf_lsm_h%end_index(j,i)
+          surf_s = surf_lsm_h(0)%start_index(j,i)
+          surf_e = surf_lsm_h(0)%end_index(j,i)
           DO  m = surf_s, surf_e
-             k   = surf_lsm_h%k(m)
-
+             k   = surf_lsm_h(0)%k(m)
              tend(k,j,i) = tend(k,j,i) + s_flux_lsm_h_up(m) * ddzw(k) * drho_air(k)
           ENDDO
 !
+!--       Natural-type surfaces, downward-facing
+          surf_s = surf_lsm_h(1)%start_index(j,i)
+          surf_e = surf_lsm_h(1)%end_index(j,i)
+          DO  m = surf_s, surf_e
+             k   = surf_lsm_h(1)%k(m)
+             tend(k,j,i) = tend(k,j,i) + s_flux_lsm_h_down(m) * ddzw(k) * drho_air(k)
+          ENDDO
+!
 !--       Urban-type surfaces, upward-facing
-          surf_s = surf_usm_h%start_index(j,i)
-          surf_e = surf_usm_h%end_index(j,i)
+          surf_s = surf_usm_h(0)%start_index(j,i)
+          surf_e = surf_usm_h(0)%end_index(j,i)
           DO  m = surf_s, surf_e
-             k   = surf_usm_h%k(m)
-
+             k   = surf_usm_h(0)%k(m)
              tend(k,j,i) = tend(k,j,i) + s_flux_usm_h_up(m) * ddzw(k) * drho_air(k)
+          ENDDO
+!
+!--       Urban-type surfaces, upward-facing
+          surf_s = surf_usm_h(1)%start_index(j,i)
+          surf_e = surf_usm_h(1)%end_index(j,i)
+          DO  m = surf_s, surf_e
+             k   = surf_usm_h(1)%k(m)
+             tend(k,j,i) = tend(k,j,i) + s_flux_usm_h_down(m) * ddzw(k) * drho_air(k)
           ENDDO
        ENDIF
@@ -665,5 +692,4 @@
           surf_e = surf_def_h(2)%end_index(j,i)
           DO  m = surf_s, surf_e
-
              k   = surf_def_h(2)%k(m)
              tend(k,j,i) = tend(k,j,i) + ( - s_flux_t(m) ) * ddzw(k) * drho_air(k)
